pub mod net;
pub mod vm;

use std::fmt;

#[derive(Debug)]
pub struct CommandError(String);

impl fmt::Display for CommandError {
    fn fmt(&self, f: &mut fmt::Formatter<'_>) -> fmt::Result {
        write!(f, "{}", self.0)
    }
}

impl std::error::Error for CommandError {}

macro_rules! cmd_error {
    ($($arg:tt)*) => {
        Box::new(CommandError(format!($($arg)*)))
    };
}

pub(crate) use cmd_error;
