// @generated automatically by Diesel CLI.

diesel::table! {
    comments (id) {
        id -> Int4,
        domain_id -> Int4,
        name -> Varchar,
        #[sql_name = "type"]
        type_ -> Varchar,
        modified_at -> Int4,
        account -> Nullable<Varchar>,
        comment -> Varchar,
    }
}

diesel::table! {
    cryptokeys (id) {
        id -> Int4,
        domain_id -> Nullable<Int4>,
        flags -> Int4,
        active -> Nullable<Bool>,
        published -> Nullable<Bool>,
        content -> Nullable<Text>,
    }
}

diesel::table! {
    domainmetadata (id) {
        id -> Int4,
        domain_id -> Nullable<Int4>,
        kind -> Nullable<Varchar>,
        content -> Nullable<Text>,
    }
}

diesel::table! {
    domains (id) {
        id -> Int4,
        name -> Varchar,
        master -> Nullable<Varchar>,
        last_check -> Nullable<Int4>,
        #[sql_name = "type"]
        type_ -> Text,
        notified_serial -> Nullable<Int8>,
        account -> Nullable<Varchar>,
        options -> Nullable<Text>,
        catalog -> Nullable<Text>,
    }
}

diesel::table! {
    instances (id) {
        id -> Int4,
        name -> Varchar,
        uuid -> Uuid,
        arec_id -> Int8,
        ptr_id -> Int8,
        lease -> Int8,
    }
}

diesel::table! {
    leases (id) {
        id -> Int8,
        subnet_id -> Int4,
        host -> Int4,
    }
}

diesel::table! {
    records (id) {
        id -> Int8,
        domain_id -> Nullable<Int4>,
        name -> Nullable<Varchar>,
        #[sql_name = "type"]
        type_ -> Nullable<Varchar>,
        content -> Nullable<Varchar>,
        ttl -> Nullable<Int4>,
        prio -> Nullable<Int4>,
        disabled -> Nullable<Bool>,
        ordername -> Nullable<Varchar>,
        auth -> Nullable<Bool>,
    }
}

diesel::table! {
    subnets (id) {
        id -> Int4,
        ifname -> Varchar,
        network -> Cidr,
    }
}

diesel::table! {
    supermasters (ip, nameserver) {
        ip -> Inet,
        nameserver -> Varchar,
        account -> Varchar,
    }
}

diesel::table! {
    tsigkeys (id) {
        id -> Int4,
        name -> Nullable<Varchar>,
        algorithm -> Nullable<Varchar>,
        secret -> Nullable<Varchar>,
    }
}

diesel::joinable!(cryptokeys -> domains (domain_id));
diesel::joinable!(domainmetadata -> domains (domain_id));
diesel::joinable!(leases -> subnets (subnet_id));

diesel::allow_tables_to_appear_in_same_query!(
    comments,
    cryptokeys,
    domainmetadata,
    domains,
    instances,
    leases,
    records,
    subnets,
    supermasters,
    tsigkeys,
);
